using System;
using System.Security.Principal;
using System.Security;

namespace LeastPrivilege
{
    internal static class NativeMethods
    {
        [System.Runtime.InteropServices.DllImport("advapi32.dll")]
        internal static extern int LogonUser(string lpszUsername, string lpszDomain, string lpszPassword, LogonType dwLogonType, ProviderType dwLogonProvider, out IntPtr phToken);

        [System.Runtime.InteropServices.DllImport("kernel32.dll")]
        internal static extern bool CloseHandle(IntPtr phToken);
    }

    enum LogonType
    {
        LOGON32_LOGON_INTERACTIVE = 2,
        LOGON32_LOGON_NETWORK = 3,
        LOGON32_LOGON_BATCH = 4,
        LOGON32_LOGON_SERVICE = 5,
        LOGON32_LOGON_UNLOCK = 7,
        LOGON32_LOGON_NETWORK_CLEARTEXT = 8,
        LOGON32_LOGON_NEW_CREDENTIALS = 9,
    }

    enum ProviderType
    {
        LOGON32_PROVIDER_DEFAULT = 0,
        LOGON32_PROVIDER_WINNT35 = 1,
        LOGON32_PROVIDER_WINNT40 = 2,
        LOGON32_PROVIDER_WINNT50 = 3
    }
}
