﻿using System;
using System.Collections.Generic;
using System.Text;
using LeastPrivilege;

namespace CheckPassword
{
    class Program
    {
        static void Main(string[] args)
        {
            bool isValid = CheckPassword("bob", ".", "secret");
            Console.WriteLine(isValid);
        }

        private static bool CheckPassword(string username, string authority, string password)
        {
            // pointer initialisieren
            IntPtr token = IntPtr.Zero;

            // token erzeugen
            NativeMethods.LogonUser(username,
                authority,
                password,
                LogonType.LOGON32_LOGON_INTERACTIVE,
                ProviderType.LOGON32_PROVIDER_DEFAULT,
                out token);

            // wenn point immer noch zero ist, dann sind die credentials falsch
            bool isValid = (token != IntPtr.Zero);

            // unmanaged handle immer wieder schliessen
            NativeMethods.CloseHandle(token);

            return isValid;
        }
    }
}
